function ig = invgray(m)

%INVGRAY Inverted gray-scale color map.
%        Modified from gray.m by M.Samal, 12 May 1994

%GRAY	Linear gray-scale color map.
%	GRAY(M) returns an M-by-3 matrix containing a gray-scale colormap.
%	GRAY, by itself, is the same length as the current colormap.
%
%	For example, to reset the colormap of the current figure:
%
%	          colormap(gray)
%
%	See also HSV, HOT, COOL, BONE, COPPER, PINK, FLAG,
%	COLORMAP, RGBPLOT.

%	Copyright (c) 1984-93 by The MathWorks, Inc.

if nargin < 1, m = size(get(gcf,'colormap'),1); end
ig = (0:m-1)'/max(m-1,1);
ig = [ig-1 ig-1 ig-1];
ig = ig*(-1);
