function [start] = start_data(scD,r)
% function for structure with start data 

[p,n] = size(scD);

        nahodny_start = 0; % selection for random start
        
        % auxiliary
        hat_A = zeros(p,r);
        hat_AA = zeros(p,r);
        hat_X = zeros(n,r);
        hat_XX = zeros(n,r);        
        
        % b
        hat_b = exp(-(1:n)/3)';
        if nahodny_start
            hat_b = rand(n,1);
        end
        
        % U
        hat_Upom = 0.00*ones(180 + n,20);
        hat_Upom(1,1) = 1; % blood
        hat_Upom(1:12,2) = 1; % parenchyma
        if n < 40 % more suitable for uptake analysis
            hat_Upom(1:5,3) = 1; % tissue background
            hat_Upom(7:20,4) = 1; % pelvis
            hat_Upom(7:40,5) = 1; % urine
            hat_Upom(5:15,6) = 1;
            hat_Upom(6:15,7) = 1;
            hat_Upom(5:15,8) = 1;
            hat_Upom(7:15,9) = 1;
            hat_Upom(4:15,10) = 1;
        else
            hat_Upom(10:20,3) = 1; % pelvis
            hat_Upom(1:5,4) = 1; % tissue background
            hat_Upom(30:60,5) = 1; % urine
            hat_Upom(5:20,6) = 1;
            hat_Upom(20:30,7) = 1;
            hat_Upom(30:40,8) = 1;
            hat_Upom(40:50,9) = 1;
            hat_Upom(49:60,10) = 1;
        end
        hat_Upom(1:50,11:20) = 1;
        hat_U = hat_Upom(1:n,1:r);
        if nahodny_start
            hat_U = rand(n,r);
        end
        
        % X - computed from b and U
        mu_X = hatB(hat_b)*hat_U;
        si_X = 0.0*mu_X.^2;
        [hat_X(:) hat_XX(:)]= momtrun_low(mu_X(:),sqrt(diag( kron(si_X,eye(n)) )),0);
        varXX = hat_XX - hat_X.^2;
        varXX = 0.1*hat_X;
        hat_XtX = hat_X'*hat_X + diag(sum(varXX));
%         keyboard
        
        % A - computed from X, scaled to [0;1] and correction of X
        mu_A = scD*hat_X*(hat_XtX)^(-1);
        if 1
            for j=1:r 
                mu_A(:,j) = mu_A(:,j) ./ max(mu_A(:,j));
            end
            hat_A = mu_A;
            hat_A(hat_A < 0) = 0;
            hat_AA = hat_A;
        end
        si_A = 0.1*ones(r,r,p);
        diagSiA = zeros(p*r,1);
        for k = 0:(r-1)
            diagSiA((1+p*k):((k+1)*p)) = si_A(k+1,k+1,:);
        end
        [hat_A(:) hat_AA(:)] = momtrun_low(mu_A(:),sqrt(diagSiA),0);
        varAA = hat_AA - hat_A.^2;
        hat_AtA = hat_A'*hat_A + diag(sum(varAA));
        
        origD = sum(sum(scD));
        compD = sum(sum(hat_A*hat_X'));
        koef = origD/compD;
        hat_X = koef*hat_X;
        hat_XtX = hat_X'*hat_X + (koef^2)*diag(sum(varXX));
        
        
        hat_b = koef*hat_b;
        varb = 0.1*hat_b;
        hat_btb = (koef^2)*hat_b'*hat_b + sum(varb);
        hat_bbt = (koef^2)*hat_b*hat_b' + diag(varb);
           
        start.A = hat_A;
        start.AtA = hat_AtA;
        start.X = hat_X;
        start.XtX = hat_XtX;
        start.b = hat_b;
        start.btb = hat_btb;
        start.bbt = hat_bbt;
        start.U = hat_U;
        start.vecU = hat_U(:);
        start.W = zeros(n,r);
        
        % upsilon
        start.upsilon = ones(n,r);
        start.upsilon_d1 = ones(n*r,1);
        start.upsilon_d2 = ones(n*r-1,1);
        
        % Xi
        start.Xi = ones(p,r);
        
        % varsigma
        start.varsigma = 1;
        
        % omega
        start.omega = abs(p/min(eig(scD'*scD)));

end


function [hatB] = hatB(mub)
% return \hat{B} from \hat{b}

n = size(mub,1);

hatB = zeros(n);

for k=0:(n-1)
    
    sour = [  ((k+1):n)'  (1:(n-k))'  ];
    for m=1:size(sour,1)
        hatB(sour(m,1),sour(m,2)) = hatB(sour(m,1),sour(m,2)) + mub(k+1);
    end
    % hatB = hatB + delta(n,k)*mub(k+1);
end

end
